// 2_image.js
// This file retrieves a single image from the API

// Includes
var request = require('request');
var http = require('http');
var fs = require('fs');
var crypto = require('crypto');
http.globalAgent.maxSockets = 1000;

// Configuration
var api_url = 'http://v3.alphapicture.com';
var api_username = 'apiuser';
var api_password = 'password';
var api_key = 'secretkey';


var requestBody = {
	"MotifId" : 4,
	"AlternativeId" : 1,
	"Lines" : {
		"1" : "Test",
		"2" : "10"
	},
	"Dimensions" : {
		"w" : 1000,
		"h" : 650
	}
};

request({
	uri : api_url + '/Image',
	method : "POST",
	encoding: null,
	headers : {
		'APIV3-Account' : api_username,
		'APIV3-Password' : api_password,
		'APIV3-Signature' : generateSignature(api_key, requestBody)
	},
	json : requestBody
}, function(error, response, body) {
	if (!error && response.statusCode == 200) {
		var filename = '2_' + (+new Date()) + '.jpg';
		fs.writeFile('./output/' + filename, body, {
			encoding : 'binary'
		}, function(err) {
			if (err) {
				console.log(err);
			} else {
				console.log("Result image saved to output/" + filename);
			}
		});
	} else {
		console.log('Error: ', error, body);
	}
});

function generateSignature(key, data) {
	var bodyHash;
	if ( typeof data == 'object') {
		bodyHash = crypto.createHash('sha512').update(JSON.stringify(data)).digest("hex");
	} else {
		bodyHash = crypto.createHash('sha512').update(data).digest("hex");
	}
	return crypto.createHash('sha512').update(bodyHash + key).digest("hex");
}

